﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Adornment_121212
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        bool isUpdated = false;
        private void chart_LayoutUpdated(object sender, EventArgs e)
        {
            if (isUpdated) return;
           foreach (var series in chart.Series)
            {            
                if (series is CustomColumnSeries)
                {
                    CustomColumnSeries columnseries = (series as CustomColumnSeries);
                    FrameworkElement element;
                    //columnseries.AdornmentsInfo
                    int index=-1;
                    foreach (var adornment in columnseries.AdornmentPresenter.Children)
                    {
                        element = (adornment as FrameworkElement);
                        index = (int)element.Tag;
                        double height = ((series as CustomColumnSeries).CustomSegment[index] as ColumnSegment).Height;
                        double width = ((series as CustomColumnSeries).CustomSegment[index] as ColumnSegment).Width;

                        // If the segment height greater than the 20 means, position the adornment
                        // in the center of the segment.
                        if (height > 20)
                        {
                            var value = series.Area.SeriesClipRect.Height - height / 2;
                            Canvas.SetTop(adornment as FrameworkElement, value);

                        }


                        if (width > 100)
                        {
                            // If the segment width greater than the 100 means, rotate the label to -90   
                            RotateTransform rotation = new RotateTransform();
                            rotation.Angle = 90;
                            element.RenderTransformOrigin = new Point(0.5, 0.5);
                            element.RenderTransform = rotation;
                        }
                        isUpdated = true;
                    }
                }
            }
        }

        private void chart_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            isUpdated = false;
        }
    }
}

